
%{

#include "stdio.h"

int a = 0;
int b = 0;

%}

%union
{
  int  szam;
  char  valtozo[16];
}

%token			PLUSZ
%token			MINUSZ
%token			KIIR
%token	<valtozo>	VALTOZO

%type	<szam>		valtoztat
%type	<szam>		valt

%%

main:
	ertekadas

main:
	kiiras

main:
	ertekadas
	main

main:
	kiiras
	main

ertekadas:
	valtoztat
	VALTOZO		{
			  printf( " %s += %d;\n", $2, $1 );
			}

kiiras:
	KIIR
	VALTOZO		{
			  if ( !strcmp( $2, "a" ) && !strcmp($2,"b") )
			  {
			    yyerror( "hibas valtozo" );
			  }

			  printf( " printf( \"%%d\\n\", %s );\n", $2 );
			}

valt:
	PLUSZ		{ $$ = 1; }

valt:
	MINUSZ		{ $$ = -1; }

valtoztat:
	valt		{ $$ = $1; }

valtoztat:
	valt
	valtoztat	{ $$ = $1 + $2; }

%%

int yyerror( char* s )
{
  printf( "Error: %s\n", s );
}

int main()
{
  printf( "int main() {\n" );
  printf( "  int a = 0;\n");
  printf( "  int b = 0;\n" );

  yyparse();

  printf( " }\n" );
  return 0;
}

